using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_user_view")]
    public class SecurityUserViewEntity : ViewEntityBase
    {

    public SecurityUserViewEntity() 
    {
    }

    [Column("user_name")]
    public string UserName  { get; set; }
    [Column("user_local_name")]
    public string UserLocalName  { get; set; }
    [Column("user_mobile")]
    public string? UserMobile  { get; set; }
    [Column("welcome_page")]
    public string? WelcomePage  { get; set; }
    [Column("actor_name")]
    public string? ActorName  { get; set; }
    [Column("actor_local_name")]
    public string? ActorLocalName  { get; set; }

    public const string USER_NAME = "UserName";
    public const string USER_LOCAL_NAME = "UserLocalName";
    public const string USER_MOBILE = "UserMobile";
    public const string WELCOME_PAGE = "WelcomePage";
    public const string ACTOR_NAME = "ActorName";
    public const string ACTOR_LOCAL_NAME = "ActorLocalName";

    public const string DB_NAME_SECURITY_USER_VIEW = "security_user_view";
    public const string DB_NAME_FIELDS="user_name,user_local_name,user_mobile,welcome_page,actor_name,actor_local_name";

    public const string DB_USER_NAME = "user_name";
    public const string DB_USER_LOCAL_NAME = "user_local_name";
    public const string DB_USER_MOBILE = "user_mobile";
    public const string DB_WELCOME_PAGE = "welcome_page";
    public const string DB_ACTOR_NAME = "actor_name";
    public const string DB_ACTOR_LOCAL_NAME = "actor_local_name";


    public static SecurityUserViewEntity GetInstance()
    {
        return new SecurityUserViewEntity();
    }

    public virtual void CopyFrom(SecurityUserViewEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityUserViewEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.UserName =  source.UserName;
        this.UserLocalName =  source.UserLocalName;
        this.UserMobile =  source.UserMobile;
        this.WelcomePage =  source.WelcomePage;
        this.ActorName =  source.ActorName;
        this.ActorLocalName =  source.ActorLocalName;

        if (includeSystemFields)
        {
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_USER_VIEW}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_USER_VIEW}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
		
        if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_USER_NAME ;  		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_USER_VIEW}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityUserViewEntity Clone()
    {
        SecurityUserViewEntity result = new SecurityUserViewEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
